set define '^' verify off
prompt ...patch_25427480.sql
--------------------------------------------------------------------------------
--
--  Copyright (c) Oracle Corporation 1999 - 2017. All Rights Reserved.
--
--    NAME
--      patch_25427480.sql
--
--    DESCRIPTION
--      Amend source query for page processes on pg 4000:4776
--
--    MODIFIED   (MM/DD/YYYY)
--    hfarrell    20/01/2017 - Created
--
--------------------------------------------------------------------------------

declare
    l_code clob;
begin

    -----------------------------------------------
    -- Create Tabular Form page process
    l_code := wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_pk1                varchar2(255)   := null;',
'  l_pk2                varchar2(255)   := null;',
'  l_pk1_source         varchar2(32767) := null;',
'  l_pk2_source         varchar2(32767) := null; ',
'  l_process            varchar2(32767) := null;',
'begin',
'  if :F4000_P4703_TABLE_PK_COLUMN != ''0'' then',
'      l_pk1 := :F4000_P4703_TABLE_PK_COLUMN;',
'  end if;',
'  if :P4703_PK2 != ''0'' then',
'      l_pk2 := :P4703_PK2;',
'  end if;',
'    ',
'  l_process := wwv_flow_wizard_api.get_owner(:FB_FLOW_ID,:F4000_P4703_TABLE_OWNER);',
'  l_process := l_process||'':''||:P4703_TABLE_NAME||'':''||l_pk1;',
'    ',
'  if l_pk2 is not null then',
'    l_process := l_process||'':''||l_pk2;',
'  end if;',
'',
'  if :P4776_PK1_SOURCE_TYPE = ''S'' then',
'      l_pk1_source := :P4776_PK1_SEQ;',
'  end if;',
'',
'  if :P4776_PK2_SOURCE_TYPE = ''S'' then',
'      l_pk2_source := :P4776_PK2_SEQ;',
'  end if;',
'',
'  wwv_flow_wizard_api.create_updateable_report (',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :f4000_p4703_report_page_id,',
'      p_page_name                => :F4000_P4703_REPORT_PAGE_NAME,',
'      p_group_name               => :P4041_GROUP_NAME,',
'      p_page_mode                => :P4039_PAGE_MODE,',
'      p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'      p_use_ui_default           => :P4041_USE_UI_DEF,',
'      --',
'      p_tabset                   => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_implement_type           => 1,',
'      p_security_group_id        => :FLOW_SECURITY_GROUP_ID,',
'      p_select_columns           => :f4000_p4703_columns,',
'      p_updatable_columns        => :P4703_RPT_COLUMNS,',
'      p_table_pk1                => l_pk1,',
'      p_table_pk1_src_type       => :P4776_PK1_SOURCE_TYPE,',
'      p_table_pk1_src            => l_pk1_source,    ',
'      p_table_pk2                => l_pk2,',
'      p_table_pk2_src_type       => :P4776_PK2_SOURCE_TYPE,',
'      p_table_pk2_src            => l_pk2_source,    ',
'      --',
'      p_query                    => wwv_flow_wizard_api.generate_updatable_rpt_query (',
'											  p_select_columns           => :f4000_p4703_columns,',
'											  p_updatable_columns        => :P4703_RPT_COLUMNS,',
'											  p_table_owner              => :F4000_P4703_TABLE_OWNER,',
'											  p_table_name               => :P4703_TABLE_NAME,',
'											  p_table_pk1                => l_pk1,',
'											  p_table_pk2                => l_pk2,',
'											  p_implement_type           => ''1''),',
'      p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID,',
'													p_page_type      => ''REPORT'' ),',
'      p_report_template          => wwv_flow_theme_dev.get_report_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID), --replace(:F4000_P33_REPORT_TEMPLATE,''%''||''null%'',null),',
'      p_region_title             => :F4000_P4703_REPORT_PAGE_NAME,',
'      p_cancel_branch            => :f4000_p4703_report_page_id,',
'      p_submit_branch            => :f4000_p4703_report_page_id,',
'      p_process                  => l_process,',
'      p_cancel_button_name       => wwv_flow_lang.system_message(''CANCEL''),',
'      p_delete_button_name       => wwv_flow_lang.system_message(''BUTTON.DELETE''),',
'      p_add_button_name          => wwv_flow_lang.system_message(''BUTTON.ADD''),',
'      p_submit_button_name       => wwv_flow_lang.system_message(''BUTTON.SUBMIT'') );',
'',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :f4000_p4703_report_page_id,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P4041_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P4041_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_entry_id => :P4041_BREADCRUMB_PARENT_ID );',
' ',
'    :FB_FLOW_PAGE_ID     := :f4000_p4703_report_page_id;',
'    :F4000_RUN_EDIT_PAGE := :f4000_p4703_report_page_id;',
'  ',
'end;'));

    update wwv_flow_step_processing
       set process_sql_clob = l_code
     where flow_id              between 4000 and 4009
       and flow_step_id         >= 4776
       and flow_step_id         < 4776 + 1
       and id                   >= 268299807147420342 
       and id                   < 268299807147420342 + 1
       and security_group_id    = 10;

    -----------------------------------------------
    -- Create a Form and Report Pages page process
    l_code := wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_edit_link       varchar2(1000) := wwv_flow_wizard_api.c_edit_image;',
'  l_pk1_source      varchar2(32767);',
'  l_pk2_source      varchar2(32767);',
'  l_rv_column       wwv_flow_global.t_dbms_id;',
'  l_rpt_page_name   varchar2(255);',
'  ',
'  l_id                  number;',
'  l_region_template     number;',
'  l_breadcrumb_entry_id number;',
'begin',
'  ',
'  if :P4776_PK1_SOURCE_TYPE = ''S'' then',
'    l_pk1_source := :P4776_PK1_SEQ;',
'  end if;',
'  ',
'  if :P4776_PK2_SOURCE_TYPE = ''S'' then',
'    l_pk2_source := :P4776_PK2_SEQ;',
'  end if;',
'',
'  if :f4000_p4703_report_page_name is null then',
'      l_rpt_page_name := wwv_flow_lang.system_message(''REPORT'');',
'  else',
'      l_rpt_page_name := :f4000_p4703_report_page_name;',
'  end if;',
'',
'  wwv_flow_wizard_api.create_query_and_update_page (',
'    p_flow_id                  => :fb_flow_id,',
'    p_form_page_id             => :f4000_p4703_flow_step_id,',
'    p_report_page_id           => :f4000_p4703_report_page_id,',
'    p_form_page_name           => :f4000_p4703_form_page_name,',
'    p_report_page_name         => l_rpt_page_name,',
'    p_group_name               => :P4041_GROUP_NAME,',
'    p_form_page_mode           => :P4039_PAGE_MODE,',
'    p_report_page_mode         => ''NORMAL'', --:P4041_PAGE_MODE,',
'    p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'    p_use_ui_default           => :P4041_USE_UI_DEF,',
'    --',
'    p_tab_set                  => :P4716_TAB_SET,',
'    p_tab_name                 => :P4716_TAB_NAME,',
'    p_tab_text                 => :P4716_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'    --',
'    p_report_type              => :P4041_IMPLEMENTATION,    ',
'    --   ',
'    p_table_owner              => :f4000_p4703_table_owner,',
'    p_table_name               => :P4703_TABLE_NAME,',
'    --',
'    p_table_pk_column_name     => :f4000_p4703_table_pk_column,',
'    p_table_pk_src_type        => :P4776_PK1_SOURCE_TYPE,',
'    p_table_pk_src             => l_pk1_source,',
'    p_table_pk2_column_name    => replace(replace(:p4703_pk2,''%''||''null%'',null),''0'',null),',
'    p_table_pk2_src_type       => :P4776_PK2_SOURCE_TYPE,',
'    p_table_pk2_src            => l_pk2_source,     ',
'    p_table_rv_column_name     => l_rv_column,',
'    --',
'    p_display_column_list      => :f4000_p4703_columns,        ',
'    p_report_select_list       => :P4703_RPT_COLUMNS, --f4000_p4703_report_select_list,',
'    p_rpt_template             => case when :P4041_IMPLEMENTATION = ''INTERACTIVE'' then  '''' else',
'	                                    wwv_flow_theme_dev.get_report_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID) end,',
'    p_rpt_region_template      => wwv_flow_theme_dev.get_region_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID,',
'													p_page_type      => ''REPORT'' ), -- :f4000_p4703_rpt_plug_template,',
'    p_rpt_region_name          => wwv_flow_lang.system_message(p_name=>''F4000_P4701_PAGE_NAME''), --:f4000_p4703_rpt_plug_name,',
'    p_form_region_template     => wwv_flow_theme_dev.get_region_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID,',
'													p_page_type      => ''FORM'' ), --:f4000_p4703_form_plug_template,        ',
'    p_form_region_name         => nvl(wwv_flow_hint.get_form_region_title (',
'													p_schema      => :F4000_P4703_TABLE_OWNER,',
'													p_table_name  => :P4703_TABLE_NAME',
'													),wwv_flow_lang.system_message(''F4000.P4039.FORM_ON'',:P4703_TABLE_NAME)), --:f4000_p4703_form_plug_name,',
'    p_where_clause             => :P4703_RPT_WHERE_CLAUSE, --f4000_p4703_where_clause,',
'    p_pagination_size          => 15, --:f4000_p4703_pagination_size,',
'    p_edit_link                => l_edit_link,',
'    --',
'    p_form_insert              => ''Y'', --:f4000_p4703_insert,',
'    p_form_update              => ''Y'', --:f4000_p4703_update,',
'    p_form_delete              => ''Y'' ); --:f4000_p4703_delete  );',
'  ',
'  :fb_flow_page_id := :f4000_p4703_report_page_id;',
'  ',
'  ',
'--',
'    l_breadcrumb_entry_id := wwv_flow_id.next_val;',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :F4000_P4703_REPORT_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P4041_BREADCRUMB_ID,',
'        p_breadcrumb_entry_id        => l_breadcrumb_entry_id,',
'        p_breadcrumb_entry_name      => :P4041_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_entry_id => :P4041_BREADCRUMB_PARENT_ID );',
'    ',
'    if :P4039_PAGE_MODE = wwv_flow_page.c_page_mode_normal then  ',
'        wwv_flow_wizard_api.create_breadcrumb_region (',
'            p_application_id             => :FB_FLOW_ID,',
'            p_page_id                    => :F4000_P4703_FLOW_STEP_ID,',
'            p_seq                        => 10,',
'            p_breadcrumb_id              => :P4041_BREADCRUMB_ID,',
'            p_breadcrumb_entry_name      => :f4000_p4703_form_page_name,',
'            p_parent_breadcrumb_entry_id => l_breadcrumb_entry_id );',
'    end if;',
'end;'));
    
    update wwv_flow_step_processing
       set process_sql_clob = l_code
     where flow_id              between 4000 and 4009
       and flow_step_id         >= 4776
       and flow_step_id         < 4776 + 1
       and id                   >= 211134043380312631 
       and id                   < 211134043380312631 + 1
       and security_group_id    = 10;
    
    -----------------------------------------------
    -- Create a Form and Report Pages page process
    l_code := wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_rpt_page_name   varchar2(255);',
'  l_region_name     varchar2(255);',
'  l_edit_link       varchar2(1000) := ''Edit'';',
'  l_pk1_source      varchar2(32767);',
'  l_pk2_source      varchar2(32767);',
'  l_rv_column       wwv_flow_global.t_dbms_id;',
'  ',
'  l_id                  number;',
'  l_region_template     number;',
'  l_breadcrumb_entry_id number;',
'  l_search_enabled     boolean    := true;',
'begin',
'  if :f4000_p4703_image = ''Other'' then',
'    l_edit_link := ''<img src="#''||''IMAGE_PREFIX#''||:f4000_p4703_other_image||''" ''||:f4000_p4703_img_attributes||'' border="0">'';',
'  elsif :f4000_p4703_image = ''Edit'' then',
'    l_edit_link := wwv_flow_lang.system_message(''EDIT'');',
'  else',
'    l_edit_link := ''<img src="#''||''IMAGE_PREFIX#''||:f4000_p4703_image||''" ''||:f4000_p4703_img_attributes||'' border="0">'';',
'  end if;',
'  ',
'  if :P4041_SEARCH_ENABLED = ''N'' then ',
'      l_search_enabled := false;',
'  end if;',
'',
'  if :P4776_PK1_SOURCE_TYPE = ''S'' then',
'    l_pk1_source := :P4776_PK1_SEQ;',
'  end if;',
'  ',
'  if :P4776_PK2_SOURCE_TYPE = ''S'' then',
'    l_pk2_source := :P4776_PK2_SEQ;',
'  end if;',
'',
'  if :f4000_p4703_report_page_name is null then',
'      l_rpt_page_name := wwv_flow_lang.system_message(''REGION_NAME.NATIVE_JQM_LIST_VIEW'');',
'  else',
'      l_rpt_page_name := :f4000_p4703_report_page_name;',
'  end if;',
'',
'  if :F4000_P4703_rpt_plug_name is null then',
'      l_region_name := wwv_flow_lang.system_message(''REGION_NAME.NATIVE_JQM_LIST_VIEW'');',
'  else',
'      l_region_name := :F4000_P4703_rpt_plug_name;',
'  end if;',
'',
'  if  :F4000_P4703_rpt_plug_template is null then',
'      select DEFAULT_FORM_TEMPLATE into l_region_template ',
'       from wwv_flow_themes where flow_id = :fb_flow_id ',
'        and theme_id = :fb_theme_id;',
'  else',
'      l_region_template :=  :F4000_P4703_rpt_plug_template;',
'  end if;',
'',
'  wwv_flow_wizard_api.create_form_and_list_view_page (',
'    p_flow_id                  => :fb_flow_id,',
'    p_form_page_id             => :F4000_P4703_flow_step_id,',
'    p_report_page_id           => :F4000_P4703_report_page_id,',
'    p_form_page_name           => :F4000_P4703_form_page_name,',
'    p_report_page_name         => l_rpt_page_name,',
'    p_group_name               => :P4041_GROUP_NAME,',
'    p_form_page_mode           => :P4039_PAGE_MODE, ',
'    p_report_page_mode         => ''NORMAL'', --:P4041_PAGE_MODE,',
'    p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'    p_use_ui_default           => :P4041_USE_UI_DEF, ',
'    --   ',
'    p_table_owner              => :F4000_P4703_table_owner,',
'    p_table_name               => :P4703_TABLE_NAME,',
'    p_table_pk_column_name     => :F4000_P4703_table_pk_column,',
'    p_table_pk_src_type        => :P4776_PK1_SOURCE_TYPE,',
'    p_table_pk_src             => l_pk1_source,',
'    p_table_pk2_column_name    => replace(replace(:P4703_pk2,''%''||''null%'',null),''0'',null),',
'    p_table_pk2_src_type       => :P4776_PK2_SOURCE_TYPE,',
'    p_table_pk2_src            => l_pk2_source,     ',
'    p_table_rv_column_name     => l_rv_column,',
'    p_display_column_list      => :F4000_P4703_columns,',
'    p_report_select_list       => :F4000_P4703_report_select_list,        ',
'    p_where_clause             => :F4000_P4703_where_clause,',
'    p_pagination_size          => 15, -- :F4000_P4703_pagination_size,',
'    --',
'    p_form_region_template     =>  wwv_flow_theme_dev.get_region_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID,',
'													p_page_type      => ''FORM'' ), -- :F4000_P4703_form_plug_template,        ',
'    p_form_region_name         =>  nvl(wwv_flow_hint.get_form_region_title (',
'													p_schema      => :F4000_P4703_TABLE_OWNER,',
'													p_table_name  => :P4703_TABLE_NAME',
'													),wwv_flow_lang.system_message(''F4000.P4039.FORM_ON'',:P4703_TABLE_NAME)), -- :F4000_P4703_form_plug_name,',
'    p_form_insert              =>  ''Y'',  -- :F4000_P4703_insert,',
'    p_form_update              =>  ''Y'',  -- :F4000_P4703_update,',
'    p_form_delete              =>  ''Y'',  -- :F4000_P4703_delete,',
'    --',
'    p_rpt_region_template      => wwv_flow_theme_dev.get_region_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID,',
'													p_page_type      => ''REPORT'' ), -- :F4000_P4703_rpt_plug_template,',
'    p_rpt_region_name          => l_region_name,',
'    p_rpt_text_column          => :P4775_TEXT_COLUMN,',
'    p_rpt_enable_search        => l_search_enabled,',
'    p_rpt_is_inset             => true,',
'    --',
'    p_nav_list_id              => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME);',
'  ',
'  :fb_flow_page_id := :F4000_P4703_report_page_id;',
'  ',
'    --  Create Breadcrumb Region on List View Page',
'    l_breadcrumb_entry_id := wwv_flow_id.next_val;',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :F4000_P4703_REPORT_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P4041_BREADCRUMB_ID,',
'        p_breadcrumb_entry_id        => l_breadcrumb_entry_id,',
'        p_breadcrumb_entry_name      => :P4041_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_entry_id => :P4041_BREADCRUMB_PARENT_ID );',
'',
'    --  Create Breadcrumb Region on Form Page',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :F4000_P4703_FLOW_STEP_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P4041_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :f4000_p4703_form_page_name,',
'        p_parent_breadcrumb_entry_id => l_breadcrumb_entry_id );',
'',
'end;'));

    update wwv_flow_step_processing
       set process_sql_clob = l_code
     where flow_id              between 4000 and 4009
       and flow_step_id         >= 4776
       and flow_step_id         < 4776 + 1
       and id                   >= 211134172806312632 
       and id                   < 211134172806312632 + 1
       and security_group_id    = 10;

    -----------------------------------------------
    -- Validation conditional change
    update wwv_flow_step_validations
       set validation_condition = ':P4776_KEY_TYPE <> ''ROWID'' and :F4000_P4703_TABLE_PK_COLUMN != ''0'''
     where flow_id              between 4000 and 4009
       and flow_step_id         >= 4776
       and flow_step_id         < 4776 + 1
       and id                   >= 15489321975890042 
       and id                   < 15489321975890042 + 1
       and security_group_id    = 10;

end;
/
commit
/
